#!/bin/sh
. /lib/netifd/netifd-wireless.sh
. /lib/netifd/hostapd.sh
+. /lib/netifd/mac80211.sh
init_wireless_driver "$@"
MP_CONFIG_BOOL="mesh_auto_open_plinks mesh_fwding"
MP_CONFIG_STRING="mesh_power_mode"
+NEWAPLIST=
+OLDAPLIST=
+NEWSPLIST=
+OLDSPLIST=
+NEWUMLIST=
+OLDUMLIST=
+
drv_mac80211_init_device_config() {
hostapd_common_add_device_config
config_add_string path phy 'macaddr:macaddr'
config_add_string hwmode
+ config_add_string tx_burst
+ config_add_string distance
config_add_int beacon_int chanbw frag rts
- config_add_int rxantenna txantenna antenna_gain txpower distance
- config_add_boolean noscan ht_coex
+ config_add_int rxantenna txantenna antenna_gain txpower
+ config_add_boolean noscan ht_coex acs_exclude_dfs
config_add_array ht_capab
config_add_array channels
config_add_boolean \
config_add_string 'macaddr:macaddr' ifname
- config_add_boolean wds powersave
+ config_add_boolean wds powersave enable
+ config_add_string wds_bridge
config_add_int maxassoc
config_add_int max_listen_int
config_add_int dtim_period
json_select config
[ "$auto_channel" -gt 0 ] && channel=acs_survey
- [ "$auto_channel" -gt 0 ] && json_get_values channel_list channels
+
+ [ "$auto_channel" -gt 0 ] && json_get_vars acs_exclude_dfs
+ [ -n "$acs_exclude_dfs" ] && [ "$acs_exclude_dfs" -gt 0 ] &&
+ append base_cfg "acs_exclude_dfs=1" "$N"
json_get_vars noscan ht_coex
- json_get_values ht_capab_list ht_capab
+ json_get_values ht_capab_list ht_capab tx_burst
+ json_get_values channel_list channels
+
+ [ "$auto_channel" = 0 ] && [ -z "$channel_list" ] && \
+ channel_list="$channel"
+
+ set_default noscan 0
+
+ [ "$noscan" -gt 0 ] && hostapd_noscan=1
+ [ "$tx_burst" = 0 ] && tx_burst=
ieee80211n=1
ht_capab=
vht_link_adapt:3 \
vht160:2
+ set_default tx_burst 2.0
append base_cfg "ieee80211ac=1" "$N"
vht_cap=0
for cap in $(iw phy "$phy" info | awk -F "[()]" '/VHT Capabilities/ { print $2 }'); do
vht_max_mpdu_hw=11454
[ "$vht_max_mpdu_hw" != 3895 ] && \
vht_capab="$vht_capab[MAX-MPDU-$vht_max_mpdu_hw]"
-
+
# maximum A-MPDU length exponent
vht_max_a_mpdu_len_exp_hw=0
[ "$(($vht_cap & 58720256))" -ge 8388608 -a 1 -le "$vht_max_a_mpdu_len_exp" ] && \
cat >> "$hostapd_conf_file" <<EOF
${channel:+channel=$channel}
${channel_list:+chanlist=$channel_list}
-${noscan:+noscan=$noscan}
+${hostapd_noscan:+noscan=1}
+${tx_burst:+tx_queue_data2_burst=$tx_burst}
$base_cfg
EOF
json_select ..
+ radio_md5sum=$(md5sum $hostapd_conf_file | cut -d" " -f1)
+ echo "radio_config_id=${radio_md5sum}" >> $hostapd_conf_file
}
mac80211_hostapd_setup_bss() {
append hostapd_cfg "$type=$ifname" "$N"
hostapd_set_bss_options hostapd_cfg "$vif" || return 1
- json_get_vars wds dtim_period max_listen_int start_disabled
+ json_get_vars wds wds_bridge dtim_period max_listen_int start_disabled
set_default wds 0
set_default start_disabled 0
- [ "$wds" -gt 0 ] && append hostapd_cfg "wds_sta=1" "$N"
+ [ "$wds" -gt 0 ] && {
+ append hostapd_cfg "wds_sta=1" "$N"
+ [ -n "$wds_bridge" ] && append hostapd_cfg "wds_bridge=$wds_bridge" "$N"
+ }
[ "$staidx" -gt 0 -o "$start_disabled" -eq 1 ] && append hostapd_cfg "start_disabled=1" "$N"
cat >> /var/run/hostapd-$phy.conf <<EOF
local phy="$1"
local idx="$(($2 + 1))"
- head -n $(($macidx + 1)) /sys/class/ieee80211/${phy}/addresses | tail -n1
+ head -n $idx /sys/class/ieee80211/${phy}/addresses | tail -n1
}
mac80211_generate_mac() {
[ "$((0x$mask1))" -gt 0 ] && {
b1="0x$1"
[ "$id" -gt 0 ] && \
- b1=$(($b1 ^ ((($id - 1) << 2) | 0x2)))
+ b1=$(($b1 ^ ((($id - !($b1 & 2)) << 2) | 0x2)))
printf "%02x:%s:%s:%s:%s:%s" $b1 $2 $3 $4 $5 $6
return
}
find_phy() {
[ -n "$phy" -a -d /sys/class/ieee80211/$phy ] && return 0
[ -n "$path" ] && {
- for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
- case "$(readlink -f /sys/class/ieee80211/$phy/device)" in
- *$path) return 0;;
- esac
- done
+ phy="$(mac80211_path_to_phy "$path")"
+ [ -n "$phy" ] && return 0
}
[ -n "$macaddr" ] && {
for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
has_ap=1
}
+mac80211_iw_interface_add() {
+ local phy="$1"
+ local ifname="$2"
+ local type="$3"
+ local wdsflag="$4"
+ local rc
+ local oldifname
+
+ iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
+ rc="$?"
+
+ [ "$rc" = 233 ] && {
+ # Device might have just been deleted, give the kernel some time to finish cleaning it up
+ sleep 1
+
+ iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
+ rc="$?"
+ }
+
+ [ "$rc" = 233 ] && {
+ # Keep matching pre-existing interface
+ [ -d "/sys/class/ieee80211/${phy}/device/net/${ifname}" ] && \
+ case "$(iw dev $ifname info | grep "^\ttype" | cut -d' ' -f2- 2>/dev/null)" in
+ "AP")
+ [ "$type" = "__ap" ] && rc=0
+ ;;
+ "IBSS")
+ [ "$type" = "adhoc" ] && rc=0
+ ;;
+ "managed")
+ [ "$type" = "managed" ] && rc=0
+ ;;
+ "mesh point")
+ [ "$type" = "mp" ] && rc=0
+ ;;
+ "monitor")
+ [ "$type" = "monitor" ] && rc=0
+ ;;
+ esac
+ }
+
+ [ "$rc" = 233 ] && {
+ iw dev "$ifname" del >/dev/null 2>&1
+ [ "$?" = 0 ] && {
+ sleep 1
+
+ iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
+ rc="$?"
+ }
+ }
+
+ [ "$rc" != 0 ] && {
+ # Device might not support virtual interfaces, so the interface never got deleted in the first place.
+ # Check if the interface already exists, and avoid failing in this case.
+ [ -d "/sys/class/ieee80211/${phy}/device/net/${ifname}" ] && rc=0
+ }
+
+ [ "$rc" != 0 ] && {
+ # Device doesn't support virtual interfaces and may have existing interface other than ifname.
+ oldifname="$(basename "/sys/class/ieee80211/${phy}/device/net"/* 2>/dev/null)"
+ [ "$oldifname" ] && ip link set "$oldifname" name "$ifname" 1>/dev/null 2>&1
+ rc="$?"
+ }
+
+ [ "$rc" != 0 ] && wireless_setup_failed INTERFACE_CREATION_FAILED
+ return $rc
+}
+
mac80211_prepare_vif() {
json_select config
- json_get_vars ifname mode ssid wds powersave macaddr
+ json_get_vars ifname mode ssid wds powersave macaddr enable wpa_psk_file vlan_file
[ -n "$ifname" ] || ifname="wlan${phy#phy}${if_idx:+-$if_idx}"
if_idx=$((${if_idx:-0} + 1))
json_add_object data
json_add_string ifname "$ifname"
json_close_object
+
+ [ "$mode" == "ap" ] && {
+ [ -z "$wpa_psk_file" ] && hostapd_set_psk "$ifname"
+ [ -z "$vlan_file" ] && hostapd_set_vlan "$ifname"
+ }
+
json_select config
# It is far easier to delete and create the desired interface
case "$mode" in
adhoc)
- iw phy "$phy" interface add "$ifname" type adhoc
+ mac80211_iw_interface_add "$phy" "$ifname" adhoc || return
;;
ap)
# Hostapd will handle recreating the interface and
mac80211_hostapd_setup_bss "$phy" "$ifname" "$macaddr" "$type" || return
+ NEWAPLIST="${NEWAPLIST}$ifname "
[ -n "$hostapd_ctrl" ] || {
- iw phy "$phy" interface add "$ifname" type __ap
+ ap_ifname="${ifname}"
hostapd_ctrl="${hostapd_ctrl:-/var/run/hostapd/$ifname}"
}
;;
mesh)
- iw phy "$phy" interface add "$ifname" type mp
+ mac80211_iw_interface_add "$phy" "$ifname" mp || return
;;
monitor)
- iw phy "$phy" interface add "$ifname" type monitor
+ mac80211_iw_interface_add "$phy" "$ifname" monitor || return
;;
sta)
local wdsflag=
- staidx="$(($staidx + 1))"
+ [ "$enable" = 0 ] || staidx="$(($staidx + 1))"
[ "$wds" -gt 0 ] && wdsflag="4addr on"
- iw phy "$phy" interface add "$ifname" type managed $wdsflag
+ mac80211_iw_interface_add "$phy" "$ifname" managed "$wdsflag" || return
+ if [ "$wds" -gt 0 ]; then
+ iw "$ifname" set 4addr on
+ else
+ iw "$ifname" set 4addr off
+ fi
[ "$powersave" -gt 0 ] && powersave="on" || powersave="off"
iw "$ifname" set power_save "$powersave"
;;
case "$mode" in
monitor|mesh)
- [ "$auto_channel" -gt 0 ] || iw dev "$ifname" set channel "$channel" $htmode
+ [ "$auto_channel" -gt 0 ] || iw dev "$ifname" set channel "$channel" $iw_htmode
;;
esac
}
mac80211_setup_supplicant() {
- wpa_supplicant_prepare_interface "$ifname" nl80211 || return 1
- wpa_supplicant_add_network "$ifname"
- wpa_supplicant_run "$ifname" ${hostapd_ctrl:+-H $hostapd_ctrl}
+ local enable=$1
+ local add_sp=0
+ local spobj="$(ubus -S list | grep wpa_supplicant.${ifname})"
+
+ [ "$enable" = 0 ] && {
+ ubus call wpa_supplicant.${phy} config_del "{\"iface\":\"$ifname\"}"
+ ip link set dev "$ifname" down
+ iw dev "$ifname" del
+ return 0
+ }
+
+ wpa_supplicant_prepare_interface "$ifname" nl80211 || {
+ iw dev "$ifname" del
+ return 1
+ }
+ if [ "$mode" = "sta" ]; then
+ wpa_supplicant_add_network "$ifname"
+ else
+ wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$noscan"
+ fi
+
+ NEWSPLIST="${NEWSPLIST}$ifname "
+
+ if [ "${NEWAPLIST%% *}" != "${OLDAPLIST%% *}" ]; then
+ [ "$spobj" ] && ubus call wpa_supplicant config_remove "{\"iface\":\"$ifname\"}"
+ add_sp=1
+ fi
+ [ -z "$spobj" ] && add_sp=1
+
+ NEW_MD5_SP=$(test -e "${_config}" && md5sum ${_config})
+ OLD_MD5_SP=$(uci -q -P /var/state get wireless._${phy}.md5_${ifname})
+ if [ "$add_sp" = "1" ]; then
+ wpa_supplicant_run "$ifname" "$hostapd_ctrl"
+ else
+ [ "${NEW_MD5_SP}" == "${OLD_MD5_SP}" ] || ubus call $spobj reload
+ fi
+ uci -q -P /var/state set wireless._${phy}.md5_${ifname}="${NEW_MD5_SP}"
+ return 0
+}
+
+mac80211_setup_supplicant_noctl() {
+ local enable=$1
+ local spobj="$(ubus -S list | grep wpa_supplicant.${ifname})"
+ wpa_supplicant_prepare_interface "$ifname" nl80211 || {
+ iw dev "$ifname" del
+ return 1
+ }
+
+ wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$noscan"
+
+ NEWSPLIST="${NEWSPLIST}$ifname "
+ [ "$enable" = 0 ] && {
+ ubus call wpa_supplicant config_remove "{\"iface\":\"$ifname\"}"
+ ip link set dev "$ifname" down
+ return 0
+ }
+ if [ -z "$spobj" ]; then
+ wpa_supplicant_run "$ifname"
+ else
+ ubus call $spobj reload
+ fi
}
-mac80211_setup_adhoc_htmode() {
+mac80211_prepare_iw_htmode() {
case "$htmode" in
- VHT20|HT20) ibss_htmode=HT20;;
+ VHT20|HT20) iw_htmode=HT20;;
HT40*|VHT40|VHT160)
case "$hwmode" in
a)
case "$(( ($channel / 4) % 2 ))" in
- 1) ibss_htmode="HT40+" ;;
- 0) ibss_htmode="HT40-";;
+ 1) iw_htmode="HT40+" ;;
+ 0) iw_htmode="HT40-";;
esac
;;
*)
case "$htmode" in
- HT40+) ibss_htmode="HT40+";;
- HT40-) ibss_htmode="HT40-";;
+ HT40+) iw_htmode="HT40+";;
+ HT40-) iw_htmode="HT40-";;
*)
if [ "$channel" -lt 7 ]; then
- ibss_htmode="HT40+"
+ iw_htmode="HT40+"
else
- ibss_htmode="HT40-"
+ iw_htmode="HT40-"
fi
;;
esac
;;
esac
- [ "$auto_channel" -gt 0 ] && ibss_htmode="HT40+"
+ [ "$auto_channel" -gt 0 ] && iw_htmode="HT40+"
;;
VHT80)
- ibss_htmode="80MHZ"
+ iw_htmode="80MHZ"
;;
NONE|NOHT)
- ibss_htmode="NOHT"
+ iw_htmode="NOHT"
;;
- *) ibss_htmode="" ;;
+ *) iw_htmode="" ;;
esac
-
}
mac80211_setup_adhoc() {
+ local enable=$1
json_get_vars bssid ssid key mcast_rate
+ NEWUMLIST="${NEWUMLIST}$ifname "
+
+ [ "$enable" = 0 ] && {
+ ip link set dev "$ifname" down
+ return 0
+ }
+
keyspec=
[ "$auth_type" = "wep" ] && {
set_default key 1
mcval=
[ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
- iw dev "$ifname" ibss join "$ssid" $freq $ibss_htmode fixed-freq $bssid \
- ${beacon_int:+beacon-interval $beacon_int} \
+ iw dev "$ifname" ibss join "$ssid" $freq $iw_htmode fixed-freq $bssid \
+ beacon-interval $beacon_int \
${brstr:+basic-rates $brstr} \
${mcval:+mcast-rate $mcval} \
${keyspec:+keys $keyspec}
}
+mac80211_setup_mesh() {
+ local enable=$1
+ json_get_vars ssid mesh_id mcast_rate
+
+ NEWUMLIST="${NEWUMLIST}$ifname "
+
+ [ "$enable" = 0 ] && {
+ ip link set dev "$ifname" down
+ return 0
+ }
+
+ mcval=
+ [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
+ [ -n "$mesh_id" ] && ssid="$mesh_id"
+
+ iw dev "$ifname" mesh join "$ssid" freq $freq $iw_htmode \
+ ${mcval:+mcast-rate $mcval} \
+ beacon-interval $beacon_int
+}
+
mac80211_setup_vif() {
local name="$1"
local failed
+ local action=up
json_select data
json_get_vars ifname
json_select config
json_get_vars mode
- json_get_var vif_txpower txpower
-
- ip link set dev "$ifname" up || {
- wireless_setup_vif_failed IFUP_ERROR
- json_select ..
- return
- }
-
- set_default vif_txpower "$txpower"
- [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
+ json_get_var vif_txpower
+ json_get_var vif_enable enable 1
+
+ [ "$vif_enable" = 1 ] || action=down
+ if [ "$mode" != "ap" ] || [ "$ifname" = "$ap_ifname" ]; then
+ ip link set dev "$ifname" "$action" || {
+ wireless_setup_vif_failed IFUP_ERROR
+ json_select ..
+ return
+ }
+ [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
+ fi
case "$mode" in
mesh)
- # authsae or wpa_supplicant
- json_get_vars key
- if [ -n "$key" ]; then
- if [ -e "/lib/wifi/authsae.sh" ]; then
- . /lib/wifi/authsae.sh
- authsae_start_interface || failed=1
- else
- wireless_vif_parse_encryption
- mac80211_setup_supplicant || failed=1
- fi
+ wireless_vif_parse_encryption
+ [ -z "$htmode" ] && htmode="NOHT";
+ freq="$(get_freq "$phy" "$channel")"
+ if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ] || chan_is_dfs "$phy" "$channel"; then
+ mac80211_setup_supplicant $vif_enable || failed=1
else
- json_get_vars mesh_id mcast_rate
-
- mcval=
- [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
-
- case "$htmode" in
- VHT20|HT20) mesh_htmode=HT20;;
- HT40*|VHT40)
- case "$hwmode" in
- a)
- case "$(( ($channel / 4) % 2 ))" in
- 1) mesh_htmode="HT40+" ;;
- 0) mesh_htmode="HT40-";;
- esac
- ;;
- *)
- case "$htmode" in
- HT40+) mesh_htmode="HT40+";;
- HT40-) mesh_htmode="HT40-";;
- *)
- if [ "$channel" -lt 7 ]; then
- mesh_htmode="HT40+"
- else
- mesh_htmode="HT40-"
- fi
- ;;
- esac
- ;;
- esac
- ;;
- VHT80)
- mesh_htmode="80Mhz"
- ;;
- VHT160)
- mesh_htmode="160Mhz"
- ;;
- *) mesh_htmode="NOHT" ;;
- esac
-
- freq="$(get_freq "$phy" "$channel")"
- iw dev "$ifname" mesh join "$mesh_id" freq $freq $mesh_htmode ${mcval:+mcast-rate $mcval}
+ mac80211_setup_mesh $vif_enable
fi
-
for var in $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING; do
json_get_var mp_val "$var"
[ -n "$mp_val" ] && iw dev "$ifname" set mesh_param "$var" "$mp_val"
;;
adhoc)
wireless_vif_parse_encryption
- mac80211_setup_adhoc_htmode
if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ]; then
- mac80211_setup_supplicant || failed=1
+ freq="$(get_freq "$phy" "$channel")"
+ mac80211_setup_supplicant_noctl $vif_enable || failed=1
else
- mac80211_setup_adhoc
+ mac80211_setup_adhoc $vif_enable
fi
;;
sta)
- mac80211_setup_supplicant || failed=1
+ mac80211_setup_supplicant $vif_enable || failed=1
;;
esac
iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep MHz | awk '{print $2}'
}
-mac80211_interface_cleanup() {
+chan_is_dfs() {
local phy="$1"
+ local chan="$2"
+ iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep -q "MHz.*radar detection"
+ return $!
+}
- for wdev in $(list_phy_interfaces "$phy"); do
+mac80211_vap_cleanup() {
+ local service="$1"
+ local vaps="$2"
+
+ for wdev in $vaps; do
+ [ "$service" != "none" ] && ubus call ${service} config_remove "{\"iface\":\"$wdev\"}"
ip link set dev "$wdev" down 2>/dev/null
iw dev "$wdev" del
done
}
+mac80211_interface_cleanup() {
+ local phy="$1"
+ local primary_ap=$(uci -q -P /var/state get wireless._${phy}.aplist)
+ primary_ap=${primary_ap%% *}
+
+ mac80211_vap_cleanup hostapd "${primary_ap}"
+ mac80211_vap_cleanup wpa_supplicant "$(uci -q -P /var/state get wireless._${phy}.splist)"
+ mac80211_vap_cleanup none "$(uci -q -P /var/state get wireless._${phy}.umlist)"
+}
+
+mac80211_set_noscan() {
+ hostapd_noscan=1
+}
+
drv_mac80211_cleanup() {
hostapd_common_cleanup
}
country chanbw distance \
txpower antenna_gain \
rxantenna txantenna \
- frag rts beacon_int htmode
+ frag rts beacon_int:100 htmode
json_get_values basic_rate_list basic_rate
json_select ..
return 1
}
- wireless_set_data phy="$phy"
- mac80211_interface_cleanup "$phy"
+ [ -z "$(uci -q -P /var/state show wireless._${phy})" ] && {
+ uci -q -P /var/state set wireless._${phy}=phy
+ wireless_set_data phy="$phy"
+ }
+
+ OLDAPLIST=$(uci -q -P /var/state get wireless._${phy}.aplist)
+ OLDSPLIST=$(uci -q -P /var/state get wireless._${phy}.splist)
+ OLDUMLIST=$(uci -q -P /var/state get wireless._${phy}.umlist)
+
+ local wdev
+ local cwdev
+ local found
+
+ for wdev in $(list_phy_interfaces "$phy"); do
+ found=0
+ for cwdev in $OLDAPLIST $OLDSPLIST $OLDUMLIST; do
+ if [ "$wdev" = "$cwdev" ]; then
+ found=1
+ break
+ fi
+ done
+ if [ "$found" = "0" ]; then
+ ip link set dev "$wdev" down
+ iw dev "$wdev" del
+ fi
+ done
# convert channel to frequency
[ "$auto_channel" -gt 0 ] || freq="$(get_freq "$phy" "$channel")"
staidx=0
[ -n "$chanbw" ] && {
- for file in /sys/kernel/debug/ieee80211/$phy/ath9k/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
+ for file in /sys/kernel/debug/ieee80211/$phy/ath9k*/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
[ -f "$file" ] && echo "$chanbw" > "$file"
done
}
- set_default rxantenna all
- set_default txantenna all
+ set_default rxantenna 0xffffffff
+ set_default txantenna 0xffffffff
set_default distance 0
set_default antenna_gain 0
+ [ "$txantenna" = "all" ] && txantenna=0xffffffff
+ [ "$rxantenna" = "all" ] && rxantenna=0xffffffff
+
iw phy "$phy" set antenna $txantenna $rxantenna >/dev/null 2>&1
- iw phy "$phy" set antenna_gain $antenna_gain
- iw phy "$phy" set distance "$distance"
+ iw phy "$phy" set antenna_gain $antenna_gain >/dev/null 2>&1
+ iw phy "$phy" set distance "$distance" >/dev/null 2>&1
+
+ if [ -n "$txpower" ]; then
+ iw phy "$phy" set txpower fixed "${txpower%%.*}00"
+ else
+ iw phy "$phy" set txpower auto
+ fi
[ -n "$frag" ] && iw phy "$phy" set frag "${frag%%.*}"
[ -n "$rts" ] && iw phy "$phy" set rts "${rts%%.*}"
has_ap=
hostapd_ctrl=
+ ap_ifname=
+ hostapd_noscan=
for_each_interface "ap" mac80211_check_ap
rm -f "$hostapd_conf_file"
+
+ for_each_interface "sta adhoc mesh" mac80211_set_noscan
[ -n "$has_ap" ] && mac80211_hostapd_setup_base "$phy"
+ mac80211_prepare_iw_htmode
for_each_interface "sta adhoc mesh monitor" mac80211_prepare_vif
+ NEWAPLIST=
for_each_interface "ap" mac80211_prepare_vif
-
+ NEW_MD5=$(test -e "${hostapd_conf_file}" && md5sum ${hostapd_conf_file})
+ OLD_MD5=$(uci -q -P /var/state get wireless._${phy}.md5)
+ if [ "${NEWAPLIST}" != "${OLDAPLIST}" ]; then
+ mac80211_vap_cleanup hostapd "${OLDAPLIST}"
+ fi
+ [ -n "${NEWAPLIST}" ] && mac80211_iw_interface_add "$phy" "${NEWAPLIST%% *}" __ap
+ local add_ap=0
+ local primary_ap=${NEWAPLIST%% *}
[ -n "$hostapd_ctrl" ] && {
- /usr/sbin/hostapd -s -P /var/run/wifi-$phy.pid -B "$hostapd_conf_file"
+ local no_reload=1
+ if [ -n "$(ubus list | grep hostapd.$primary_ap)" ]; then
+ [ "${NEW_MD5}" = "${OLD_MD5}" ] || {
+ ubus call hostapd.$primary_ap reload
+ no_reload=$?
+ if [ "$no_reload" != "0" ]; then
+ mac80211_vap_cleanup hostapd "${OLDAPLIST}"
+ mac80211_vap_cleanup wpa_supplicant "$(uci -q -P /var/state get wireless._${phy}.splist)"
+ mac80211_vap_cleanup none "$(uci -q -P /var/state get wireless._${phy}.umlist)"
+ sleep 2
+ mac80211_iw_interface_add "$phy" "${NEWAPLIST%% *}" __ap
+ for_each_interface "sta adhoc mesh monitor" mac80211_prepare_vif
+ fi
+ }
+ fi
+ if [ "$no_reload" != "0" ]; then
+ add_ap=1
+ ubus wait_for hostapd
+ ubus call hostapd config_add "{\"iface\":\"$primary_ap\", \"config\":\"${hostapd_conf_file}\"}"
+ local hostapd_pid=$(ubus call service list '{"name": "hostapd"}' | jsonfilter -l 1 -e "@['hostapd'].instances['hostapd'].pid")
+ wireless_add_process "$hostapd_pid" "/usr/sbin/hostapd" 1
+ fi
ret="$?"
- wireless_add_process "$(cat /var/run/wifi-$phy.pid)" "/usr/sbin/hostapd" 1
[ "$ret" != 0 ] && {
wireless_setup_failed HOSTAPD_START_FAILED
return
}
}
+ uci -q -P /var/state set wireless._${phy}.aplist="${NEWAPLIST}"
+ uci -q -P /var/state set wireless._${phy}.md5="${NEW_MD5}"
- for_each_interface "ap sta adhoc mesh monitor" mac80211_setup_vif
+ [ "${add_ap}" = 1 ] && sleep 1
+ for_each_interface "ap" mac80211_setup_vif
+ NEWSPLIST=
+ NEWUMLIST=
+
+ for_each_interface "sta adhoc mesh monitor" mac80211_setup_vif
+
+ uci -q -P /var/state set wireless._${phy}.splist="${NEWSPLIST}"
+ uci -q -P /var/state set wireless._${phy}.umlist="${NEWUMLIST}"
+
+ local foundvap
+ local dropvap=""
+ for oldvap in $OLDSPLIST; do
+ foundvap=0
+ for newvap in $NEWSPLIST; do
+ [ "$oldvap" = "$newvap" ] && foundvap=1
+ done
+ [ "$foundvap" = "0" ] && dropvap="$dropvap $oldvap"
+ done
+ [ -n "$dropvap" ] && mac80211_vap_cleanup wpa_supplicant "$dropvap"
wireless_set_up
}
-list_phy_interfaces() {
+_list_phy_interfaces() {
local phy="$1"
if [ -d "/sys/class/ieee80211/${phy}/device/net" ]; then
ls "/sys/class/ieee80211/${phy}/device/net" 2>/dev/null;
fi
}
+list_phy_interfaces() {
+ local phy="$1"
+
+ for dev in $(_list_phy_interfaces "$phy"); do
+ readlink "/sys/class/net/${dev}/phy80211" | grep -q "/${phy}\$" || continue
+ echo "$dev"
+ done
+}
+
drv_mac80211_teardown() {
wireless_process_kill_all
json_select ..
mac80211_interface_cleanup "$phy"
+ uci -q -P /var/state revert wireless._${phy}
}
add_driver mac80211